module MeasureMethod
  module Metrics
    def self.out=(o)
      @out = o
    end

    def self.out
      @out || Logger
    end

    def self.sample(name:, val:, data: {})
      met_log("sample", name, val, data)
    end

    def self.count(name:, val: 1, data: {})
      met_log("count", name, val, data)
    end

    def self.measure(name:, val: nil, data: {}, &block)
      return measure_block(name: name, data: data, &block) if block
      met_log("measure", name, val, data)
    end

    def self.metricfy(name)
      name.
        gsub('::', '.').
        gsub(' ', '.').
        gsub(/(\/)/, '.').
        gsub(/([A-Z]+)([A-Z][a-z])/,'\1_\2').
        gsub(/([a-z\d])([A-Z])/,'\1_\2').
        gsub(/_/,"-").
        downcase
    end

    def self.met_log(type, name, val, data)
      data["#{type}##{name}"] = val
      out.log(data)
    end

    def self.measure_block(name:, data: {}, &block)
      out.log(data.merge({starting: name}))
      start = Time.now
      result = yield
      elapsed = (Time.now.to_f - start.to_f) * 1000
      measure(name: name, val: elapsed.round.to_s+"ms", data: data)
      result
    end
  end
end
